openapi: "3.0.0"
info:
  description: "Specification of login api"
  version: "0.1.0"
  title: "Login portal"
  termsOfService: "http://swagger.io/terms/"
  contact:
    email: "support@neueda.com"

tags:
- name: "login"
  description: "Login portal"

paths:
  /users:
    get:
      description: Returns all users from the system
      responses:
        '200':
          description: A list of users.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/User'
  /users/id:
    get:
      description: Returns user based on ID
      summary: Find user by ID
      operationId: getUserById
      responses:
        '200':
          description: user response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/User'
        default:
          description: error payload
          content:
            'text/html':
              schema:
                $ref: '#/components/schemas/ErrorResponse'
    parameters:
    - name: id
      in: path
      description: ID of pet to use
      required: true
      schema:
        type: integer
        minimum: 1
        
  /login:
    post:
      description: sends login data
      summary: login user in
      operationId: login
      requestBody:
        description: Post of login data
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/User'
      responses:
        '200':
          description: successful login response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Token'
        '403':
          description: unauthorized login
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        default:
          description: error payload
          content:
            'text/html':
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                
  /register:
    post:
      description: user registers
      summary: user registration endpoint
      operationId: register
      requestBody:
        description: registertaion post
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/User'
      responses:
        '200':
          description: successful registration response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UserId'
        default:
          description: error payload
          content:
            'text/html':
              schema:
                $ref: '#/components/schemas/ErrorResponse'
                
  
components:
  schemas:
    Token:
      type: object
      properties:
        access_token:
          type: string
      required: 
        - access_token
        
    UserId:
      type: object
      properties:
        id:
          type: string
      required: 
        - id
          
    User:
      type: object
      properties:
        id:
          type: integer
        username:
          type: string
        password: 
          type: string
      required: 
        - username
        - password
    
    ErrorResponse:
      type: object
      properties:
        error-message:
          type: string
      required: 
        - error-message
